'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var cache = {};

var Storage = function Storage() {
	var _this = this;

	var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	_classCallCheck(this, Storage);

	Object.keys(Storage.defaults).map(function (key) {
		_this[key] = opts.hasOwnProperty(key) ? opts[key] : Storage.defaults[key];
	});
};

exports.default = Storage;


Storage.defaults = {
	storage: typeof window !== 'undefined' ? window.localStorage : null };

Storage.create = function (opts) {
	return new Storage(opts);
};

Storage.cache = cache;

Storage.prototype.cache = cache;

Storage.prototype.get = function (key) {
	try {
		return this.storage.getItem(key);
	} catch (e) {
		return this.cache[key];
	}
};

Storage.prototype.set = function (key, value) {
	try {
		this.storage.setItem(key, value);
		return value;
	} catch (e) {
		return this.cache[key] = value;
	}
};

Storage.prototype.remove = function (key) {
	try {
		this.storage.removeItem(key);
	} catch (e) {
		delete this.cache[key];
	}
};