'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _defaults = require('./defaults');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Config = function Config() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _defaults.configOpts;

    _classCallCheck(this, Config);

    this.assign(opts);
};

Config.prototype.defaults = _defaults.configOpts;

Config.prototype.assign = function (opts) {
    var config = this;
    Object.keys(_defaults.configOpts).map(function (key) {
        config[key] = opts.hasOwnProperty(key) ? opts[key] : _defaults.configOpts[key];
    });
};

exports.default = new Config();