'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.updateProfile = exports.getProfile = undefined;

var _config = require('./internals/config');

var _config2 = _interopRequireDefault(_config);

var _defaults = require('./internals/defaults');

var _utils = require('./internals/utils');

var _shared = require('./shared');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getProfile = exports.getProfile = function getProfile(options) {
	var baseUrl = _config2.default.baseUrl,
	    profileUrl = _config2.default.profileUrl;

	var url = baseUrl + profileUrl;
	var opts = Object.assign({}, _defaults.fetchOpts, {
		method: 'GET',
		headers: Object.assign({}, _defaults.fetchOpts.headers, (0, _shared.getAuthHeader)())
	}, options);
	return fetch(url, opts).then(_utils.checkResponseStatus).then(_utils.parseResponseToJSON);
};

var updateProfile = exports.updateProfile = function updateProfile(profileData, options) {
	var baseUrl = _config2.default.baseUrl,
	    profileUrl = _config2.default.profileUrl;

	var url = baseUrl + profileUrl;
	var opts = Object.assign({}, _defaults.fetchOpts, {
		method: 'PUT',
		headers: Object.assign({}, _defaults.fetchOpts.headers, (0, _shared.getAuthHeader)()),
		body: JSON.stringify(profileData)
	}, options);
	return fetch(url, opts).then(_utils.checkResponseStatus);
};